import { __classPrivateFieldGet, __classPrivateFieldSet } from 'tslib';
import * as i0 from '@angular/core';
import { Injectable } from '@angular/core';

var _ComponentLoader_createdComponent, _ComponentLoader_creationState, _ComponentLoader_viewContainer;
class ComponentLoader {
    constructor() {
        _ComponentLoader_createdComponent.set(this, void 0);
        _ComponentLoader_creationState.set(this, false);
        _ComponentLoader_viewContainer.set(this, void 0);
    }
    get createdComponent() {
        return __classPrivateFieldGet(this, _ComponentLoader_createdComponent, "f");
    }
    get creationState() {
        return __classPrivateFieldGet(this, _ComponentLoader_creationState, "f");
    }
    static findViewContainerKey(component) {
        let containerKey;
        for (const [index, key] of Object.keys(component).entries()) {
            if (this.isViewContainer(component[key])) {
                containerKey = key;
                break;
            }
        }
        return containerKey;
    }
    static isViewContainer(value) {
        return Object.prototype.hasOwnProperty.call(value, '_hostLView');
    }
    assignProperties(object, ...keys) {
        if (Array.isArray(keys) && keys.length > 0) {
            keys.forEach((key) => {
                Object.assign(this.createdComponent?.instance, {
                    [key]: object[key],
                });
            });
        }
        else {
            Object.assign(this.createdComponent?.instance, object);
        }
        return this;
    }
    createComponent(componentType, viewContainer = __classPrivateFieldGet(this, _ComponentLoader_viewContainer, "f"), options) {
        ComponentLoader.isViewContainer(viewContainer) &&
            !this.isComponentCreated() &&
            ((__classPrivateFieldSet(this, _ComponentLoader_createdComponent, viewContainer.createComponent(componentType, options), "f")),
                (__classPrivateFieldSet(this, _ComponentLoader_creationState, this.isComponentCreated(), "f")));
        typeof __classPrivateFieldGet(this, _ComponentLoader_viewContainer, "f") === 'undefined' &&
            (__classPrivateFieldSet(this, _ComponentLoader_viewContainer, viewContainer, "f"));
        return this;
    }
    destroyComponent() {
        this.isComponentCreated() &&
            (__classPrivateFieldGet(this, _ComponentLoader_createdComponent, "f")?.destroy(),
                (__classPrivateFieldSet(this, _ComponentLoader_createdComponent, undefined, "f")),
                __classPrivateFieldGet(this, _ComponentLoader_viewContainer, "f").clear());
        __classPrivateFieldSet(this, _ComponentLoader_creationState, typeof __classPrivateFieldGet(this, _ComponentLoader_createdComponent, "f") === 'undefined', "f");
        return __classPrivateFieldGet(this, _ComponentLoader_creationState, "f");
    }
    getPropertyValue(key) {
        return __classPrivateFieldGet(this, _ComponentLoader_createdComponent, "f")?.instance[key];
    }
    isComponentCreated() {
        return typeof __classPrivateFieldGet(this, _ComponentLoader_createdComponent, "f") === 'object';
    }
    linkProperties(names, target) {
        names.forEach((name) => this.linkProperty(name, target));
        return this;
    }
    linkProperty(name, target) {
        Object.defineProperty(__classPrivateFieldGet(this, _ComponentLoader_createdComponent, "f")?.instance, name, {
            get() {
                const key = name;
                return target[key];
            },
        });
        return this;
    }
    pickViewContainer(component) {
        const key = ComponentLoader.findViewContainerKey(component);
        return (typeof key === 'string' && this.setViewContainer(component[key]),
            this);
    }
    setPropertyValue(key, value) {
        Object.assign(__classPrivateFieldGet(this, _ComponentLoader_createdComponent, "f")?.instance, {
            [key]: value,
        });
        return this;
    }
    setViewContainer(container) {
        return (ComponentLoader.isViewContainer(container) &&
            (__classPrivateFieldSet(this, _ComponentLoader_viewContainer, container, "f")),
            this);
    }
    unlinkProperties(...names) {
        names.forEach((name) => Object.defineProperty(__classPrivateFieldGet(this, _ComponentLoader_createdComponent, "f")?.instance, name, {
            writable: true,
            value: __classPrivateFieldGet(this, _ComponentLoader_createdComponent, "f")?.instance[name],
        }));
        return this;
    }
}
_ComponentLoader_createdComponent = new WeakMap(), _ComponentLoader_creationState = new WeakMap(), _ComponentLoader_viewContainer = new WeakMap();

class ComponentLoaderService extends ComponentLoader {
    static findServiceKey(object) {
        let serviceKey;
        Object.keys(object).forEach((key) => ComponentLoaderService.isService(object[key]) &&
            (serviceKey = key));
        return serviceKey;
    }
    static isService(value) {
        return typeof value === 'object' && value instanceof ComponentLoaderService;
    }
}
ComponentLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.3", ngImport: i0, type: ComponentLoaderService, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
ComponentLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.2.3", ngImport: i0, type: ComponentLoaderService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.3", ngImport: i0, type: ComponentLoaderService, decorators: [{
            type: Injectable
        }] });

function loadComponent(component, target, config) {
    var _LoadComponent_service;
    class LoadComponent extends target {
        constructor() {
            super(...arguments);
            _LoadComponent_service.set(this, void 0);
        }
        ngOnInit() {
            if (typeof config === 'object' &&
                Object.prototype.hasOwnProperty.call(config, 'service')) {
                typeof config?.service === 'string' &&
                    ComponentLoaderService.isService(this[config.service]) &&
                    (__classPrivateFieldSet(this, _LoadComponent_service, this[config.service], "f"));
            }
            else if (typeof __classPrivateFieldGet(this, _LoadComponent_service, "f") === 'undefined') {
                const service = ComponentLoaderService.findServiceKey(this);
                typeof service === 'string' && (__classPrivateFieldSet(this, _LoadComponent_service, this[service], "f"));
            }
            super.ngOnInit?.apply(this, arguments);
        }
        ngAfterViewInit() {
            typeof config === 'object' &&
                Object.prototype.hasOwnProperty.call(config, 'container')
                ? typeof config.container === 'string' &&
                    __classPrivateFieldGet(this, _LoadComponent_service, "f").setViewContainer(this[config.container])
                : __classPrivateFieldGet(this, _LoadComponent_service, "f").pickViewContainer(this);
            __classPrivateFieldGet(this, _LoadComponent_service, "f").createComponent(component);
            typeof config === 'object' &&
                Object.prototype.hasOwnProperty.call(config, 'properties') &&
                Array.isArray(config.properties) &&
                __classPrivateFieldGet(this, _LoadComponent_service, "f").linkProperties(config.properties, this);
            super.ngAfterViewInit?.apply(this, arguments);
        }
    }
    _LoadComponent_service = new WeakMap();
    LoadComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.3", ngImport: i0, type: LoadComponent, deps: null, target: i0.ɵɵFactoryTarget.Injectable });
    LoadComponent.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.2.3", ngImport: i0, type: LoadComponent });
    i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.3", ngImport: i0, type: LoadComponent, decorators: [{
                type: Injectable
            }] });
    return LoadComponent;
}

const LoadComponent = (component, config) => (target) => loadComponent(component, target, config);

export { ComponentLoader, ComponentLoaderService, LoadComponent };
//# sourceMappingURL=angular-package-component-loader.mjs.map
