import { ComponentRef, Injector, NgModuleRef, Type, ViewContainerRef } from '@angular/core';
export declare abstract class ComponentLoader<DynamicComponent> {
    #private;
    get createdComponent(): ComponentRef<DynamicComponent> | undefined;
    get creationState(): boolean;
    static findViewContainerKey(component: {
        [k: string]: any;
    }): string | undefined;
    static isViewContainer(value: any): value is ViewContainerRef;
    assignProperties<Obj extends object, Key extends keyof DynamicComponent>(object: Obj, ...keys: Key[]): this;
    createComponent(componentType: Type<DynamicComponent>, viewContainer?: ViewContainerRef, options?: {
        index?: number;
        injector?: Injector;
        ngModuleRef?: NgModuleRef<unknown>;
        projectableNodes?: Node[][];
    }): this;
    destroyComponent(): boolean;
    getPropertyValue<Key extends keyof DynamicComponent>(key: Key): DynamicComponent[Key] | undefined;
    isComponentCreated(): boolean;
    linkProperties<Target extends object, Name extends keyof DynamicComponent>(names: Name[], target: Target): this;
    linkProperty<Target extends object, Name extends keyof DynamicComponent>(name: Name, target: Target): this;
    pickViewContainer(component: {
        [k: string]: any;
    }): this;
    setPropertyValue<Key extends keyof DynamicComponent>(key: Key, value: DynamicComponent[Key]): this;
    setViewContainer(container: ViewContainerRef): this;
    unlinkProperties<Name extends keyof DynamicComponent>(...names: Name[]): this;
}
